i3 improvements wip
[distro-setup] / toggle-mute
1 #!/bin/bash
2 # I, Ian Kelling, follow the GNU license recommendations at
3 # https://www.gnu.org/licenses/license-recommendations.en.html. They
4 # recommend that small programs, < 300 lines, be licensed under the
5 # Apache License 2.0. This file contains or is part of one or more small
6 # programs. If a small program grows beyond 300 lines, I plan to change
7 # to a recommended GPL license.
8
9 # Copyright 2024 Ian Kelling
10
11 # Licensed under the Apache License, Version 2.0 (the "License");
12 # you may not use this file except in compliance with the License.
13 # You may obtain a copy of the License at
14
15 # http://www.apache.org/licenses/LICENSE-2.0
16
17 # Unless required by applicable law or agreed to in writing, software
18 # distributed under the License is distributed on an "AS IS" BASIS,
19 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
20 # See the License for the specific language governing permissions and
21 # limitations under the License.
22
23
24 if ! test "$BASH_VERSION"; then echo "error: shell is not bash" >&2; exit 1; fi
25 shopt -s inherit_errexit 2>/dev/null ||: # ignore fail in bash < 4.4
26 set -eE -o pipefail
27 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" exit status: $?, PIPESTATUS: ${PIPESTATUS[*]}" >&2' ERR
28
29
30 mute=true
31 volume_level=0
32
33 # mute / unmute instead of toggle.
34 if [[ $1 ]]; then
35 case $1 in
36 mute)
37 mute=true
38 ;;
39 unmute)
40 mute=false
41 ;;
42 esac
43 else
44
45 muted=$(pactl get-source-mute @DEFAULT_SOURCE@ | awk '{print $2}' ||:)
46 case $muted in
47 no) : ;;
48 yes) mute=false; volume_level=1 ;;
49 *)
50 i3-nagbar -m "FAILED TO GET PULSE MUTE STATE" -t error -f "pango:monospace 30"
51 ;;
52 esac
53 fi
54
55 # we double mute here because it could be useful, and I figured out how
56 # and feel like using what I know.
57
58 pactl set-source-mute @DEFAULT_SOURCE@ $mute
59
60 # note: condition duplicated in stream-clip, myi3statsus
61 if pgrep -fc '^ffmpeg.*icecast://source.*/fsf' >/dev/null; then
62 out=$(echo Parsed_volume_1 volume $volume_level | zmqsend ||:)
63 if [[ $out != "0 Success" ]]; then
64 i3-nagbar -m "FAILED to set ffmpeg volume to $volume_level" -t error -f "pango:monospace 30"
65 fi
66 fi